"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _fs = _interopRequireDefault(require("fs"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _electron = require("electron");

var rmDir = function rmDir(dirPath, removeSelf) {
  console.info("Clearing folder ".concat(dirPath));

  if (removeSelf === undefined) {
    removeSelf = true;
  }

  var files;

  try {
    files = _fs["default"].readdirSync(dirPath);
    console.info("Removing files: ".concat(files));
  } catch (e) {
    return;
  }

  if (files.length > 0) {
    for (var i = 0; i < files.length; i++) {
      var filePath = "".concat(dirPath, "/").concat(files[i]);

      if (_fs["default"].statSync(filePath).isFile()) {
        _fs["default"].unlinkSync(filePath);
      } else {
        rmDir(filePath);
      }
    }
  }

  if (removeSelf) {
    _fs["default"].rmdirSync(dirPath);
  }
}; // platform related


var DataStorage = /*#__PURE__*/function () {
  function DataStorage() {
    (0, _classCallCheck2["default"])(this, DataStorage);
  }

  (0, _createClass2["default"])(DataStorage, null, [{
    key: "init",
    value: function init() {
      // Create the user data directory if it does not exist
      this.userDataDir = _electron.app.getPath('userData');

      _mkdirp["default"].sync(this.userDataDir);

      this.tmpDir = "".concat(this.userDataDir, "/Tmp");
      this.sessionDir = "".concat(this.userDataDir, "/Sessions");

      _mkdirp["default"].sync(this.tmpDir);

      _mkdirp["default"].sync(this.sessionDir);

      this.clear();
    }
  }, {
    key: "clear",
    value: function clear() {
      try {
        rmDir(this.tmpDir, false);
        rmDir(this.sessionDir, false);
      } catch (e) {
        console.error(e);
      }
    }
  }]);
  return DataStorage;
}();

(0, _defineProperty2["default"])(DataStorage, "userDataDir", void 0);
(0, _defineProperty2["default"])(DataStorage, "tmpDir", void 0);
(0, _defineProperty2["default"])(DataStorage, "sessionDir", void 0);
var _default = DataStorage;
exports["default"] = _default;