"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.configureWindow = configureWindow;
exports.getMainWindow = getMainWindow;
exports.setMainWindow = setMainWindow;

var _electron = require("electron");

// The selection menu
var selectionMenu = _electron.Menu.buildFromTemplate([{
  role: 'copy'
}]); // The input menu


var inputMenu = _electron.Menu.buildFromTemplate([{
  role: 'copy'
}, {
  role: 'paste'
}]);

function configureWindow(window) {
  // Open every external link in a new window
  // https://github.com/electron/electron/blob/master/docs/api/web-contents.md
  window.webContents.on('new-window', function (event, url) {
    event.preventDefault();

    _electron.shell.openExternal(url);
  }); // https://github.com/electron/electron/issues/4068#issuecomment-274159726

  window.webContents.on('context-menu', function (event, props) {
    var selectionText = props.selectionText,
        isEditable = props.isEditable;

    if (isEditable) {
      // Shows an input menu if editable
      inputMenu.popup(window);
    } else if (selectionText && String(selectionText).trim() !== '') {
      selectionMenu.popup(window);
    }
  });
}

var mainWindow = null;

function getMainWindow() {
  return mainWindow;
}

function setMainWindow(window) {
  mainWindow = window;
}